<TeXmacs|1.0.7.13>

<style|<tuple|article|twelf|kam_de_bruijn>>

<\body>
  <section|Krivine abstract machine>

  <subsection|Syntax>

  <subsubsection*|Unary numbers>

  <meta-decl#rev|<unary>|<meta-type#datatype>>

  <meta-name|<unary>|n>

  \;

  <meta-decl#grammar|<unary_Z>|<unary#>>

  <meta-decl#entry|<unary_S|<unary#>>|<math|<unary>>>

  <subsubsection*|Term>

  <meta-decl#rev|<term>|<meta-type#datatype>>

  <\meta-name|<term>>
    t
  </meta-name>

  \;

  <meta-decl#grammar|<t_var|<unary#>>|<term#>>

  <meta-decl#entry|<t_app|<term#1>|<term#2>>|<math|<term>>>

  <meta-decl#entry|<t_lam|<term#>>|<math|<term>>>

  <subsubsection*|Closure and environment>

  <meta-decl#rev|<clos>|<meta-type#datatype>>

  <\meta-name|<clos>>
    c
  </meta-name>

  \;

  <meta-decl#rev|<cenv>|<meta-type#datatype>>

  <\meta-name|<cenv>>
    \<cal-E\>
  </meta-name>

  \;

  <meta-decl#grammar|<clos_closure|<term#>|<cenv#>>|<clos#>>

  \;

  <meta-decl#grammar|<cenv_empty>|<cenv#>>

  <meta-decl#entry|<cenv_cons|<cenv#>|<clos#>>|<math|<cenv>>>

  <subsubsection*|Stack>

  <meta-decl#rev|<stack>|<meta-type#datatype>>

  <\meta-name|<stack>>
    \<cal-S\>
  </meta-name>

  \;

  <meta-decl#grammar|<stack_empty>|<stack#>>

  <meta-decl#entry|<stack_cons|<clos#>|<stack#>>|<math|<stack>>>

  <subsubsection*|State>

  <meta-decl#rev|<state>|<meta-type#datatype>>

  <\meta-name|<state>>
    \<sigma\>
  </meta-name>

  \;

  <meta-decl#grammar|<state_triple|<term#>|<cenv#>|<stack#>>|<state#>>

  <subsection|Judgments>

  \;

  <meta-decl|<fetch|<cenv#>|<unary#>|<clos#>>|<meta-type>>

  <meta-decl|<evaluation|<state#1>|<state#2>>|<meta-type>>

  <subsection|Fetch>

  <\meta-defn>
    <meta-rule||<fetch|<cenv_cons|\<cal-E\>|c>|<unary_Z>|c>|fetch<rsub|1>>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<fetch|\<cal-E\>|n|c>|<fetch|<cenv_cons|\<cal-E\>|c<rprime|'>>|<unary_S|n>|c>|fetch<rsub|2>>
  </meta-defn>

  <meta-mode|<fetch|+\<cal-E\>|+n|-c>>

  <meta-worlds|<meta-paren|><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-terminates|\<cal-E\><space|1em><fetch|\<cal-E\>|n|c>>

  <meta-unique|<fetch|+\<cal-E\>|+n|-1c>>

  <subsection|Evaluation>

  <\meta-defn>
    <meta-rule|<fetch|\<cal-E\>|n|<clos_closure|t|\<cal-E\><rprime|'>>>|<evaluation|<state_triple|<t_var|n>|\<cal-E\>|\<cal-S\>>|<state_triple|t|\<cal-E\><rprime|'>|\<cal-S\>>>|step_var>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<meta-paren|<t_app|t<rsub|1>|t<rsub|2>>>|\<cal-E\>|\<cal-S\>>|<state_triple|t<rsub|1>|\<cal-E\>|<stack_cons|<clos_closure|t<rsub|2>|\<cal-E\>>|\<cal-S\>>>>|step_app>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<evaluation|<state_triple|<t_lam|t>|\<cal-E\>|<stack_cons|c|\<cal-S\>>>|<state_triple|t|<cenv_cons|\<cal-E\>|c>|\<cal-S\>>>|step_abs>
  </meta-defn>

  \;

  <meta-mode|<evaluation|+\<sigma\><rsub|1>|-\<sigma\><rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><evaluation|\<sigma\><rsub|1>|\<sigma\><rsub|2>>>

  <meta-unique|<evaluation|+\<sigma\><rsub|1>|-1\<sigma\><rsub|2>>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.4|1>>
    <associate|auto-11|<tuple|1.4|2>>
    <associate|auto-12|<tuple|1.2|?>>
    <associate|auto-13|<tuple|1.2|?>>
    <associate|auto-14|<tuple|1.2|?>>
    <associate|auto-15|<tuple|1.2|?>>
    <associate|auto-16|<tuple|1.3|?>>
    <associate|auto-17|<tuple|1.4|?>>
    <associate|auto-18|<tuple|1.4|?>>
    <associate|auto-19|<tuple|1.4|?>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1|1>>
    <associate|auto-4|<tuple|1.1|1>>
    <associate|auto-5|<tuple|1.1|1>>
    <associate|auto-6|<tuple|1.1|1>>
    <associate|auto-7|<tuple|1.1|1>>
    <associate|auto-8|<tuple|1.2|1>>
    <associate|auto-9|<tuple|1.3|1>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Krivine
      abstract machine with catch/throw> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|Unary numbers
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|Term <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|Closure and environment
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|Stack <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|State <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Judgments
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Fetch
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Evaluation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>
    </associate>
  </collection>
</auxiliary>