<TeXmacs|1.0.7.13>

<style|<tuple|article|twelf|stlc_de_bruijn>>

<\body>
  <section|Computation and deduction (Chapter<nbsp>6)>

  <meta-begin>

  <subsection|Syntax>

  <subsubsection*|Expressions>

  <meta-decl#0|<expr>|<meta-type#2>>

  <meta-name|<expr>|E>

  \;

  <meta-decl#1|<e_app|<expr#1>|<expr#2>>|<expr#>>

  <meta-decl#2|<e_lam|<expr#x>|<expr#>>|<expr>>

  \;

  <meta-bind|1|2|<e_lam|<meta-wildcard>|<meta-wildcard>>>

  <subsubsection*|Modified de Bruijn Expressions>

  <meta-decl#0|<expr'>|<meta-type#2>>

  <meta-name|<expr'>|F>

  \;

  <meta-decl#1|<e_one>|<expr'#>>

  <meta-decl#2|<e_shift|<expr'#>>|<expr'>>

  <meta-decl#2|<e_lam'|<expr'#>>|<expr'>>

  <meta-decl#2|<e_app'|<expr'#1>|<expr'#2>>|<expr'>>

  <subsubsection*|Environments and values>

  <meta-decl#0|<cenv>|<meta-type#2>>

  <meta-name|<cenv>|\<eta\>>

  \;

  <meta-decl#0|<val>|<meta-type#2>>

  <meta-name|<val>|W>

  \;

  <meta-decl#1|<cenv_empty>|<cenv#>>

  <meta-decl#2|<cenv_cons|<cenv#>|<val#>>|<cenv>>

  \;

  <meta-decl#1|<clo|<cenv#>|<expr'#>>|<val#>>

  \;

  <subsection|Judgments>

  <meta-decl#0|<eeval|<expr#1>|<expr#2>>|<meta-type#1>>

  <\meta-defn>
    <meta-rule||<eeval|<e_lam|x|<meta-app#0|e|x>>|<e_lam|x|<meta-app#0|e|x>>>|ev_lam>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<meta-hyps|<eeval|e<rsub|1>|<e_lam|x|<meta-app#0|e<rsub|1><rprime|'>|x>>>|<meta-hyps|<eeval|e<rsub|2>|v<rsub|2>>|<eeval|<meta-app#0|e<rsub|1><rprime|'>|v<rsub|2>>|v>>>|<eeval|<e_app|e<rsub|1>|e<rsub|2>>|v>|ev_app>
  </meta-defn>

  \;

  <meta-mode|<eeval|+E<rsub|1>|-E<rsub|2>>>

  <meta-worlds|<meta-paren|><space|1em><eeval|E<rsub|1>|E<rsub|2>>>

  <meta-unique|<eeval|+E<rsub|1>|-1E<rsub|2>>>

  \;

  <meta-decl#0|<feval|<cenv#>|<expr'#>|<val#>>|<meta-type#1>>

  <\meta-defn>
    <meta-rule||<feval|<cenv_cons|\<eta\>|W>|<e_one>|W>|fev_1>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<feval|\<eta\>|F|W>|<feval|<cenv_cons|\<eta\>|W>|<e_shift|F>|W>|fev_\<uparrow\>>
  </meta-defn>

  <\meta-defn>
    <meta-rule||<feval|\<eta\>|<e_lam'|F>|<clo|\<eta\>|<e_lam'|F>>>|fev_lam>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<meta-hyps|<feval|\<eta\>|F<rsub|1>|<clo|\<eta\><rprime|'>|<e_lam'|F<rsub|1><rprime|'>>>>|<meta-hyps|<feval|\<eta\>|F<rsub|2>|W<rsub|2>>|<feval|<cenv_cons|\<eta\><rprime|'>|W<rsub|2>>|F<rsub|1><rprime|'>|W>>>|<feval|\<eta\>|<e_app'|F<rsub|1>|F<rsub|2>>|W>|fev_app>
  </meta-defn>

  <meta-mode|<feval|+\<eta\>|+F|-W>>

  <meta-worlds|<meta-paren|><space|1em><feval|\<eta\>|F|W>>

  <meta-unique|<feval|+\<eta\>|+F|-1W>>

  <subsubsection*|Example>

  <meta-solve|<feval|<cenv_empty>|<e_app'|<meta-paren|<e_lam'|<meta-paren|<e_lam'|<meta-paren|<e_shift|<e_one>>>>>>>|<meta-paren|<e_lam'|<e_one>>>>|W>>

  \;

  <meta-decl#0|<trans|<cenv#>|<expr'#>|<expr#>>|<meta-type#1>>

  <meta-decl#0|<vtrans|<val#>|<expr#>>|<meta-type#1>>

  <\meta-defn>
    <meta-rule|<meta-all|w|<meta-all|x|<meta-imp|<vtrans|w|x>|<trans|<cenv_cons|\<eta\>|w>|F|<meta-app#0|e|x>>>>>|<trans|\<eta\>|<e_lam'|F>|<e_lam|x|<meta-app#0|e|x>>>|tr_lam>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<meta-hyps|<trans|\<eta\>|F<rsub|1>|e<rsub|1>>|<trans|\<eta\>|F<rsub|2>|e<rsub|2>>>|<trans|\<eta\>|<e_app'|F<rsub|1>|F<rsub|2>>|<e_app|e<rsub|1>|e<rsub|2>>>|tr_app>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<vtrans|W|e>|<trans|<cenv_cons|\<eta\>|W>|<e_one>|e>|tr_1>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<trans|\<eta\>|F|e>|<trans|<cenv_cons|\<eta\>|W>|<e_shift|F>|e>|tr_\<uparrow\>>
  </meta-defn>

  <\meta-defn>
    <meta-rule|<trans|\<eta\>|<e_lam'|F>|<e_lam|x|<meta-app#0|e|x>>>|<vtrans|<clo|\<eta\>|<e_lam'|F>>|<e_lam|x|<meta-app#0|e|x>>>|vtr_lam>
  </meta-defn>

  <meta-block-decl|\<cal-W\><rsub|0>|<meta-block|<meta-braces|<meta-typed-var|w|<val>>><meta-braces|<meta-typed-var|x|<expr>>><meta-braces|<meta-typed-var|<meta-wildcard>|<vtrans|w|x>>>>>

  <meta-mode|<next-line><space|2em><trans|+\<eta\>|+F|-e><next-line><space|2em><vtrans|+W|-v>>

  <meta-worlds|<meta-paren|\<cal-W\><rsub|0>><next-line><space|2em><trans|\<eta\>|F|e><next-line><space|2em><vtrans|W|v>>

  <meta-unique|<next-line><space|2em><trans|+\<eta\>|+F|-1e><next-line><space|2em><vtrans|+W|-1v>>

  \;

  <meta-solve|<trans|<cenv_empty>|<e_app'|<meta-paren|<e_lam'|<meta-paren|<e_lam'|<meta-paren|<e_shift|<e_one>>>>>>>|<meta-paren|<e_lam'|<e_one>>>>|<e_app|<meta-paren|<e_lam|x|<e_lam|y|x>>>|<meta-paren|<e_lam|v|v>>>>>

  <meta-solve|<trans|<cenv_empty>|F|<e_app|<meta-paren|<e_lam|x|<e_lam|y|x>>>|<meta-paren|<e_lam|v|v>>>>>

  <meta-solve|<trans|<cenv_empty>|<e_app'|<meta-paren|<e_lam'|<meta-paren|<e_lam'|<meta-paren|<e_shift|<e_one>>>>>>>|<meta-paren|<e_lam'|<e_one>>>>|e>>

  \;

  <meta-decl#0|<map_eval|<eeval|e|v>|<trans|\<eta\>|F|e>|<feval|\<eta\>|F|W>|<vtrans|W|v>>|<meta-type#1>>

  \;

  <\meta-defn>
    <meta-rule||<map_eval|<meta-rule|||ev_lam>|<meta-rule|<meta-rule|<meta-rule|\<cal-C\><rsub|2>||tr_lam>||vtr_lam>||tr_1>|<meta-rule|||fev_1>|<meta-rule|<meta-rule|\<cal-C\><rsub|2>||tr_lam>||vtr_lam>>|mp_1>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule|<map_eval|\<cal-D\>|\<cal-C\><rsub|1>|\<cal-D\><rprime|'><rsub|1>|\<cal-U\><rsub|1>>|<map_eval|\<cal-D\>|<meta-rule|\<cal-C\><rsub|1>||tr_\<uparrow\>>|<meta-rule|\<cal-D\><rprime|'><rsub|1>||fev_\<uparrow\>>|\<cal-U\><rsub|1>>|mp_\<uparrow\>>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule||<map_eval|<meta-rule|||ev_lam>|<meta-rule|\<cal-C\><rsub|1>||tr_lam>|<meta-rule|||fev_lam>|<meta-rule|<meta-rule|\<cal-C\><rsub|1>||tr_lam>||vtr_lam>>|mp_lam>
  </meta-defn>

  \;

  <\meta-defn>
    <meta-rule|<meta-hyps#0|<map_eval|\<cal-D\><rsub|1>|\<cal-C\><rsub|1>|\<cal-D\><rsub|1><rprime|'>|<meta-rule|<meta-rule|\<cal-C\><rsub|3>||tr_lam>||vtr_lam>>|<meta-hyps#0|<map_eval|\<cal-D\><rsub|2>|\<cal-C\><rsub|2>|\<cal-D\><rsub|2><rprime|'>|\<cal-U\><rsub|2>>|<map_eval|\<cal-D\><rsub|3>|<meta-app|<meta-app|<meta-app|\<cal-C\><rsub|3>|\<cal-W\><rsub|2>>|\<cal-V\><rsub|2>>|\<cal-U\><rsub|2>>|\<cal-D\><rsub|3><rprime|'>|\<cal-U\><rsub|3>>>>|<map_eval|<meta-rule|<meta-hyps|\<cal-D\><rsub|1>|<meta-hyps|\<cal-D\><rsub|2>|\<cal-D\><rsub|3>>>||ev_app>|<meta-rule|<meta-hyps|\<cal-C\><rsub|1>|\<cal-C\><rsub|2>>||tr_app>|<meta-rule|<meta-hyps|\<cal-D\><rprime|'><rsub|1>|<meta-hyps|\<cal-D\><rprime|'><rsub|2>|\<cal-D\><rprime|'><rsub|3>>>||fev_app>|\<cal-U\><rsub|3>>|mp_app>
  </meta-defn>

  \;

  <\remark*>
    The above rules correspond to the following Twelf code:

    \;

    <\verbatim>
      mp_1 : map_eval (ev_lam) (tr_1 (vtr_lam (tr_lam C2)))<next-line>
      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ (fev_1) (vtr_lam (tr_lam C2)).

      \;

      mp_uparrow : map_eval D (tr_uparrow C1) (fev_uparrow D1') U1<next-line>
      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \<less\>- map_eval D C1 D1' U1.

      \;

      mp_lam : map_eval (ev_lam) (tr_lam C1)<next-line>
      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ (fev_lam) (vtr_lam (tr_lam C1)).

      \;

      mp_app : map_eval (ev_app D3 D2 D1) (tr_app C2 C1) (fev_app D3' D2'
      D1') U3<next-line> \ \ \ \ \ \ \ \ \ \ \ \ \ \ \<less\>- map_eval D1 C1
      D1' (vtr_lam (tr_lam C3))<next-line>
      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \<less\>- map_eval D2 C2 D2' U2<next-line>
      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \<less\>- map_eval D3 (C3 W2 V2 U2) D3' U3.
    </verbatim>
  </remark*>

  \;

  <meta-mode|<map_eval|-\<cal-D\>|+\<cal-C\>|+\<cal-D\><rprime|'>|-\<cal-U\>>>

  <meta-block-decl|b<rsub|1>|<meta-block|<meta-braces|<meta-typed-var|x|<expr>>>>>

  <meta-worlds|<meta-paren|b<rsub|1>><space|1em><map_eval|\<cal-D\>|\<cal-C\>|\<cal-D\><rprime|'>|\<cal-U\>>>

  <meta-total|<meta-paren|\<cal-D\><rprime|'>><space|1em><map_eval|\<cal-D\>|\<cal-C\>|\<cal-D\><rprime|'>|\<cal-U\>>>

  <\remark*>
    These properties do not hold:

    <meta-mode|<map_eval|+\<cal-D\>|+\<cal-C\>|-\<cal-D\><rprime|'>|-\<cal-U\>>>

    <meta-terminates|<meta-paren|\<cal-D\>><space|1em><map_eval|\<cal-D\>|\<cal-C\>|\<cal-D\><rprime|'>|\<cal-U\>>>
  </remark*>

  <meta-theorem|thm|<next-line><space|2em><meta-forallG|<meta-paren|<meta-pi|<meta-braces|<meta-typed-var|x|<expr>>>>><next-line><space|2em><meta-forall*|<meta-braces|e><meta-braces|W><meta-braces|F><meta-braces|\<eta\>><next-line><space|2em><meta-forall|<meta-braces|<meta-typed-var|\<cal-D\><rprime|'>|<feval|\<eta\>|F|W>>><next-line><space|3em><meta-braces|<meta-typed-var|\<cal-C\>|<trans|\<eta\>|F|e>>><next-line><space|2em><meta-exists|<meta-braces|v><meta-braces|<meta-typed-var|\<cal-D\>|<eeval|e|v>>><meta-braces|<meta-typed-var|\<cal-U\>|<vtrans|W|v>>>>>>>>

  <\remark*>
    The theorem prover loops:

    <meta-prove|5<space|1em>\<cal-D\><rprime|'><space|1em><meta-paren|thm<space|1spc>\<cal-D\><rprime|'><space|1spc>\<cal-C\><space|1spc>v<space|1spc>\<cal-D\><space|1spc>\<cal-U\>>>
  </remark*>

  \;

  <meta-end>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-orientation|portrait>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-10|<tuple|1.3|1>>
    <associate|auto-11|<tuple|1.4|2>>
    <associate|auto-12|<tuple|1.4|?>>
    <associate|auto-13|<tuple|1.2|?>>
    <associate|auto-14|<tuple|1.2|?>>
    <associate|auto-15|<tuple|1.2|?>>
    <associate|auto-16|<tuple|1.3|?>>
    <associate|auto-17|<tuple|1.4|?>>
    <associate|auto-18|<tuple|1.4|?>>
    <associate|auto-19|<tuple|1.4|?>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.1|1>>
    <associate|auto-4|<tuple|1.1|1>>
    <associate|auto-5|<tuple|1.1|1>>
    <associate|auto-6|<tuple|1.2|1>>
    <associate|auto-7|<tuple|1.2|2>>
    <associate|auto-8|<tuple|1.4|1>>
    <associate|auto-9|<tuple|1.4|1>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Computation
      and deduction (Chapter <no-break><specific|screen|<resize|<move|<with|color|<quote|#A0A0FF>|->|-0.3em|>|0em||0em|>>6)>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Syntax
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|3fn>|Expressions
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|3fn>|Modified de Bruijn Expressions
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|Environments and values
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Judgments
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|3fn>|Example <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>
    </associate>
  </collection>
</auxiliary>