<TeXmacs|1.0.7.13>

<style|<tuple|seminar|twelf|System_F|cite-author-year|slides>>

<\body>
  <\padded>
    <doc-data|<doc-title|<with|font-base-size|7|<with|color|dark
    blue|<next-line>Monadic reflection in Lax
    Logic>>>||<doc-author-data|<author-name|>|<\author-address>
      \;

      \;
    </author-address>>|<\doc-author-data|<author-name|<space|2em><math|Tristan>
    Crolard>>
      \;
    <|doc-author-data>
      \;
    <|doc-author-data|<\author-address>
      <space|2em><with|font-base-size|12|LACL -- University of East Paris>

      \;

      \;

      <with|font-shape|italic|<space|2em>TPDC'11<next-line><space|2em>Novi
      Sad -- May 29, 2011>
    </author-address>>
      \;
    </doc-author-data>|<\doc-author-data>
      \;
    </doc-author-data>>
  </padded>

  <\slide5|Introduction||Revisit ``<with|font-shape|italic|Representing
  monads>'' <cite|Filinski94> from a logical
  standpoint.|<with|font-series|bold|Goal:> understand the logical meaning of
  <strong|shift>/<strong|reset> in the restricted framework of a major
  application, i.e. implementing monadic reflection.>
    Through the formulas-as-types interpretation, a monad
    <monad|<meta-wildcard>> corresponds

    to the modality from Lax logic <cite|Curry52>:

    \;

    <\eqnarray*>
      <tformat|<table|<row|<cell|<typing|<return>|<arrow|\<varphi\>|<monad|\<varphi\>>>>>|<cell|<space|2em>>|<cell|<typing|<pbind>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<psi\>>>>|<arrow|<monad|\<varphi\>>|<monad|\<psi\>>>>>>>>>
    </eqnarray*>

    \;
  <|slide5>
    Monadic reflection is given by these logical rules:

    \;

    <\eqnarray*>
      <tformat|<table|<row|<cell|<meta-rule|\<Gamma\><typing|t|\<varphi\>>|\<Gamma\><typing|<reify|t>|<monad|\<varphi\>>>|<rsub|>reify>>|<cell|>|<cell|<meta-rule|\<Gamma\><typing|t|<monad|\<varphi\>>>|\<Gamma\><typing|<reflect|t>|\<varphi\>>|<rsub|>reflect>>>>>
    </eqnarray*>

    \;
  </slide5|In this talk, we consider only
  <with|font-shape|italic|provability>.||||>

  <slide|Example: the exception monad>

  \;

  <\padded>
    <meta-decl|<exn>|<tp>>

    <meta-abbrev|<monad|\<varphi\>>|<disjunction|\<varphi\>|<exn>>>

    \;

    <meta-abbrev|<return>|<lam|a|\<varphi\>|<inl|a>>>

    <meta-abbrev|<pbind><space|0.6spc>f|\<lambda\>t.<cases|t|a|<app|f|a>|b|<inr|b>>>

    \;

    \;

    Defining <strong|raise> and <strong|handle> in direct style:

    \;

    <meta-abbrev|<raise|t>|<reflect|<inr|t>>>

    \;

    <meta-abbrev|<handle|t|e|h>|<cases|<reify|t>|a|a|e|h>>
  </padded>

  <slide|Moggi's monadic translation (CBV)>

  \;

  <\padded>
    Translation of types (<math|\<sigma\>> atomic):

    <\itemize>
      <item><with|mode|math|\<sigma\><rsup|\<diamondsuit\>>\<equiv\>\<sigma\>>

      <item><with|mode|math|<around|(|\<varphi\>\<Rightarrow\>\<psi\>|)><rsup|\<diamondsuit\>>\<equiv\>\<varphi\><rsup|\<diamondsuit\>>\<Rightarrow\>\<diamondsuit\>\<psi\><rsup|\<diamondsuit\>>>

      <item><with|mode|math|<around|(|<monad|>\<psi\>|)><rsup|\<diamondsuit\>>\<equiv\><monad|>\<varphi\><rsup|\<diamondsuit\>>>
    </itemize>

    Translation of terms:

    <\itemize>
      <item><with|mode|math|x<rsup|\<diamondsuit\>>\<equiv\><app|<return>|x>>

      <item><with|mode|math|<around*|(|\<lambda\>x.t|)><rsup|\<diamondsuit\>>\<equiv\><app|<return>|\<lambda\>x.t<rsup|\<diamondsuit\>>>>

      <item><math|<meta-paren|<app|t<rsub|1>|t<rsub|2>>><rsup|\<diamondsuit\>>\<equiv\><pbind><space|0.6spc><around*|(|\<lambda\>f.<around*|(|<pbind><space|0.6spc>f<space|0.6spc>t<rsub|2><rsup|\<diamondsuit\>>|)>|)><space|0.6spc>t<rsub|1><rsup|\<diamondsuit\>>>

      <item><em|<math|<reflect|t><rsup|\<diamondsuit\>>\<equiv\><app|<app|<pbind>|><math-it|id>|t<rsup|\<diamondsuit\>>>>>

      <item><em|<math|<reify|t><rsup|\<diamondsuit\>>\<equiv\><space|0.6spc><app|<return>|t<rsup|\<diamondsuit\>>>>>
    </itemize>

    <\lemma*>
      If <math|\<Gamma\>\<vdash\>t:\<varphi\>> is derivable then
      <math|><with|mode|math|\<Gamma\><rsup|\<diamondsuit\>>\<vdash\>t<rsup|\<diamondsuit\>>:\<diamondsuit\>\<varphi\><rsup|><rsup|\<diamondsuit\>>>
      is derivable.
    </lemma*>

    <paragraph|Proof.>

    <\eqnarray*>
      <tformat|<table|<row|<cell|<dfrac|\<Gamma\><rsup|\<diamondsuit\>><typing|t<rsup|\<diamondsuit\>>|\<diamondsuit\>\<varphi\><rsup|><rsup|\<diamondsuit\>>>|\<Gamma\><rsup|\<diamondsuit\>><typing|<app|<return>|t<rsup|\<diamondsuit\>>>|\<diamondsuit\><monad|\<varphi\><rsup|><rsup|\<diamondsuit\>>>>>
      <small|<around*|[|unit|]>>>|<cell|<space|2em>>|<cell|<dfrac|\<Gamma\><rsup|\<diamondsuit\>><typing|t<rsup|\<diamondsuit\>>|\<diamondsuit\><monad|\<varphi\><rsup|><rsup|\<diamondsuit\>>>>|\<Gamma\><rsup|\<diamondsuit\>><typing|<app|<app|<pbind>|><math-it|id>|t<rsup|\<diamondsuit\>>>|\<diamondsuit\>\<varphi\><rsup|><rsup|\<diamondsuit\>>>>
      <small|<around*|[|join|]>>>>>>
    </eqnarray*>
  </padded>

  <slide|Filinski's CPS-translation (CBV)>

  \;

  <\padded>
    Define <math|<kmonad|\<varphi\>><space|0.6spc>=<space|0.6spc><arrow|<meta-paren|<arrow|\<varphi\>|<monad|o>>>|<monad|o>>>
    where <math|o> is some <em|universal answer type> (not \ sound).

    \;

    Translation of types (<math|\<sigma\>> atomic):

    <\itemize>
      <item><with|mode|math|\<sigma\><rsup|\<nabla\>>\<equiv\>\<sigma\>>

      <item><with|mode|math|<around|(|\<varphi\>\<Rightarrow\>\<psi\>|)><rsup|\<nabla\>>\<equiv\>\<varphi\><rsup|\<nabla\>>\<Rightarrow\>\<nabla\>\<psi\><rsup|\<nabla\>>>

      <item><with|mode|math|<around|(|<monad|>\<psi\>|)><rsup|\<nabla\>>\<equiv\><monad|>\<varphi\><rsup|\<nabla\>>>
    </itemize>

    Translation of terms:

    <\itemize>
      <item><with|mode|math|x<rsup|\<nabla\>>\<equiv\><app|\<lambda\>k.k|x>>

      <item><with|mode|math|<around*|(|\<lambda\>x.t|)><rsup|<with|font-series|bold|\<nabla\>>>\<equiv\><app|\<lambda\>k.k|<around*|(|\<lambda\>x.t<rsup|\<nabla\>>|)>>>

      <item><math|<meta-paren|<app|t<rsub|1>|t<rsub|2>>><rsup|\<nabla\>>\<equiv\>\<lambda\>k.t<rsup|\<nabla\>><rsub|1><space|0.6spc><around*|(|\<lambda\>f.t<rsup|\<nabla\>><rsub|2><space|0.6spc><around*|(|\<lambda\>a.f<space|0.6spc>a<space|0.6spc>k|)>|)>>

      <item><em|<math|<reflect|t><rsup|\<nabla\>>\<equiv\>><with|mode|math|\<lambda\>k.t<rsup|\<nabla\>><space|0.6spc><around*|(|<pbind><space|0.6spc>k|)>>>

      <item><em|<math|<reify|t><rsup|\<nabla\>>\<equiv\><space|0.6spc>\<lambda\>k.k<space|0.6spc><around*|(|t<rsup|\<nabla\>><space|0.6spc><return>|)>>>
    </itemize>
  </padded>

  \;

  <slide|Delimited control>

  \;

  <\padded>
    <\padded>
      Reflect/reify are <with|font-shape|italic|definable in direct style>
      from <strong|shift>/<strong|reset> <cite|Filinski94>
    </padded>

    <space|1em><space|1em><space|1.2spc><meta-abbrev|<reify|t>|<app|<mreset>|<meta-paren|<app|<return>|t>>>>

    <space|1em><space|1em><meta-abbrev|<reflect|t>|<app|<mshift>|<meta-paren|\<lambda\>k.<app|<app|<pbind>|k>|t>>>>

    \;

    That is, these equations are valid:

    <\itemize>
      <item><with|mode|math|<meta-paren|<app|<mreset>|<meta-paren|<app|<return>|t>>>><rsup|\<nabla\>>=<reify|t><rsup|\<nabla\>>>

      <item><with|mode|math|<meta-paren|<app|<mshift>|<meta-paren|\<lambda\>k.<app|<app|<pbind>|k>|t>>>><rsup|\<nabla\>>=<reflect|t><rsup|\<nabla\>>>
    </itemize>

    where:

    <\itemize>
      <item><with|mode|math|<math-bf|reset><rsup|\<nabla\>>=\<lambda\>m.\<lambda\>c.<around*|(|c<space|0.6spc><around*|(|m<space|0.6spc><math-it|id>|)>|)>>

      <item><with|mode|math|<math-bf|shift><rsup|\<nabla\>>=\<lambda\>h.\<lambda\>c.<around*|(|h<space|0.6spc><around*|(|\<lambda\>v.\<lambda\>c<rprime|'>.c<rprime|'><space|0.6spc><around*|(|c<space|0.6spc>v|)>|)><space|0.6spc><math-it|id>|)>>
    </itemize>
  </padded>

  \;

  \;

  <slide|Answer type polymorphism>

  \;

  \;

  <\padded>
    Footnote from ``<with|font-shape|italic|Representing monads>'':

    \;

    <space|2em>``Alternatively, <em|with a little more care>, we can take
    <math|\<nabla\>\<varphi\>=\<forall\>\<alpha\><around*|(|\<varphi\>\<rightarrow\><monad|>\<alpha\>|)>\<rightarrow\><monad|>\<alpha\>;><space|1em>it
    is straightforward to check that both the term translation and the
    operations <space|1em>defined in the following can in fact be typed
    according to this schema.''

    \;

    So, let us do it <with|font-shape|italic|carefully>:

    <\itemize>
      <item>Formalization in Twelf (work in progress)

      <item>Experimenting with TeXmacs as a front end

      (the Twelf source is generated from the slides)
    </itemize>
  </padded>

  \;

  <slide|Plan of the rest of the talk>

  \;

  <\padded>
    <\itemize>
      <item>Formalize System <with|font-shape|italic|F> in Twelf

      <item>Check that the operations are well-typed in direct style

      <item>Check that the CPS-translations of the operations are well-typed

      <item>Interpret the logical type of <strong|shift> for the usual
      monads:

      <\itemize-minus>
        <item>continuation monad

        <item>state monad

        <item>exception monad
      </itemize-minus>
    </itemize>
  </padded>

  <slide|System <with|font-shape|italic|F> (HOAS)>

  \;

  \;

  <subsection|<em|Types>>

  <meta-begin>

  <meta-decl|<tp>|<meta-type>>

  <meta-decl|<arrow|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<tp>|<tp>>>>

  <meta-decl|<product|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<tp>|<tp>>>>

  <meta-decl|<disjunction|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<tp>|<tp>>>>

  \;

  <meta-decl|<for_all|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<meta-paren|<meta-imp|<tp>|<tp>>>|<tp>>>

  <meta-bind|1|2|<for_all|<meta-wildcard>|<meta-wildcard>>>

  \;

  <meta-abbrev|<bottom>|<for_all|\<beta\>|\<beta\>>>

  \;

  <slide|Terms>

  \;

  <meta-decl|<tm>|<meta-type>>

  \;

  <\padded>
    <em|Abstraction>
  </padded>

  <meta-decl|<lam|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tp>|<meta-imp|<meta-paren|<meta-imp|<tm>|<tm>>>|<tm>>>>

  \;

  <meta-bind|1|3|<lam|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  \;

  <\padded>
    <em|Application>
  </padded>

  <meta-decl|<app|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tm>|<tm>>>>

  \;

  <\padded>
    <em|Polymorphic abstraction>
  </padded>

  <meta-decl|<lam2|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<meta-paren|<meta-imp|<tp>|<tm>>>|<tm>>>

  \;

  <meta-bind|1|2|<lam2|<meta-wildcard>|<meta-wildcard>>>

  \;

  <\padded>
    <em|Instantiation>
  </padded>

  <meta-decl|<inst|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tp>|<tm>>>>

  \;

  <\padded>
    <em|Derived syntax for <with|font-series|bold|let>>
  </padded>

  <meta-abbrev|<letv|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-abs|\<tau\>|<meta-abs|u|<meta-abs|t|<app|<meta-paren|<lam|x|\<tau\>|<meta-app#0|t|x>>>|u>>>>>

  \;

  <meta-bind|1|4|<letv|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  \;

  <\padded>
    <em|Pairing>
  </padded>

  <meta-decl|<pair|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tm>|<tm>>>>

  \;

  <\padded>
    <em|Pattern matching>
  </padded>

  <meta-decl|<let|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<meta-paren|<meta-imp|<tm>|<meta-imp|<tm>|<tm>>>>|<tm>>>>

  \;

  <meta-bind|2|4|<let|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  <meta-bind|1|4|<let|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  \;

  \;

  <\padded>
    <em|Injections>
  </padded>

  <meta-decl|<inl|<meta-wildcard>>|<meta-imp|<tm>|<tm>>>

  <meta-decl|<inr|<meta-wildcard>>|<meta-imp|<tm>|<tm>>>

  \;

  <\padded>
    <em|Pattern matching>
  </padded>

  <meta-decl|<cases|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<meta-paren|<meta-imp|<tm>|<tm>>><next-line><space|19em>|<meta-imp|<meta-paren|<meta-imp|<tm>|<tm>>>|<tm>>>>>

  \;

  <meta-bind|4|5|<cases|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  <meta-bind|2|3|<cases|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>|<meta-wildcard>>>

  \;

  <\padded>
    <em|Monadic constants>
  </padded>

  <meta-decl|<return>|<tm>>

  <meta-decl|<pbind>|<tm>>

  \;

  <\padded>
    <em|Delimited control operators>
  </padded>

  <meta-decl|<mreset>|<tm>>

  <meta-decl|<mshift>|<tm>>

  \;

  <slide|Typing judgment>

  \;

  \;

  \;

  <meta-decl|<typing|<meta-wildcard>|<meta-wildcard>>|<meta-imp|<tm>|<meta-imp|<tp>|<meta-type>>>>

  \;

  \;

  <meta-defn|<meta-rule|<meta-all|x|<meta-imp|<typing|x|\<varphi\>>|<typing|<meta-app#0|t|x>|\<psi\>>>>|<typing|<lam|x|\<varphi\>|<meta-app#0|t|x>>|<arrow|\<varphi\>|\<psi\>>>|&lam>>

  <meta-defn|<meta-rule|<meta-hyps|<typing|t<rsub|1>|<arrow|\<varphi\>|\<psi\>>>|<typing|t<rsub|2>|\<varphi\>>>|<typing|<app|t<rsub|1>|t<rsub|2>>|\<psi\>>|&app>>

  <meta-defn|<meta-rule|<meta-all|\<alpha\>|<typing|<meta-app#0|t|\<alpha\>>|<meta-app#0|\<psi\>|\<alpha\>>>>|<typing|<lam2|\<alpha\>|<meta-app#0|t|\<alpha\>>>|<for_all|\<alpha\>|<meta-app#0|\<psi\>|\<alpha\>>>>|&abs>>

  <meta-defn|<meta-rule|<typing|t|<for_all|\<alpha\>|<meta-app#0|\<psi\>|\<alpha\>>>>|<typing|<inst|t|\<varphi\>>|<meta-app#0|\<psi\>|\<varphi\>>>|&inst>>

  \;

  \;

  <slide|Typing judgment>

  \;

  \;

  <meta-defn|<meta-rule|<meta-hyps|<typing|t<rsub|1>|\<varphi\>>|<typing|t<rsub|2>|\<psi\>>>|<typing|<pair|t<rsub|1>|t<rsub|2>>|<product|\<varphi\>|\<psi\>>>|&pair>>

  <meta-defn|<meta-rule|<meta-hyps|<meta-all|x|<meta-imp|<typing|x|\<varphi\>>|<meta-paren|<meta-all|y|<meta-imp|<typing|y|\<psi\>>|<typing|<meta-app#0|<meta-app#0|u|x>|y>|\<tau\>>>>>>>|<typing|t|<product|\<varphi\>|\<psi\>>>>|<typing|<let|x|y|t|<meta-app#0|<meta-app#0|u|x>|y>>|\<tau\>>|&match>>

  \;

  <meta-defn|<meta-rule|<typing|t|\<psi\>>|<typing|<inr|t>|<disjunction|\<varphi\>|\<psi\>>>|&inr>>

  <meta-defn|<meta-rule|<typing|t|\<varphi\>>|<typing|<inl|t>|<disjunction|\<varphi\>|\<psi\>>>|&inl>>

  <meta-defn|<meta-rule|<meta-hyps|<meta-all|x|<meta-imp|<typing|x|\<varphi\>>|<typing|<meta-app#0|u<rsub|1>|x>|\<phi\>>>>|<meta-hyps|<meta-all|y|<meta-imp|<typing|y|\<psi\>>|<typing|<meta-app#0|u<rsub|2>|y>|\<phi\>>>>|<typing|t|<disjunction|\<varphi\>|\<psi\>>>>>|<typing|<cases|t|x|<meta-app#0|u<rsub|1>|x>|y|<meta-app#0|u<rsub|2>|y>>|\<phi\>>|&case>>

  \;

  \;

  <slide|Lax logic>

  \;

  <\padded>
    <em|Primitive monad or lax modality <cite|Curry52>>
  </padded>

  <meta-decl|<monad|<meta-wildcard>>|<meta-imp|<tp>|<tp>>>

  \;

  <meta-defn|<meta-rule#0||<typing|<return>|<arrow|\<varphi\>|<monad|\<varphi\>>>>|&unit>>

  <meta-defn|<meta-rule#0||<typing|<pbind>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<psi\>>>>|<arrow|<monad|\<varphi\>>|<monad|\<psi\>>>>>|&bind>>

  \;

  <slide|Delimited control>

  \;

  <\padded>
    <em|Fixed answer type>
  </padded>

  <meta-decl|<answer>|<tp>>

  \;

  <meta-defn|<meta-rule#0||<typing|<mreset>|<arrow|<monad|\<varphi\>>|<monad|\<varphi\>>>>|&reset>>

  <meta-defn|<meta-rule#0||<typing|<mshift>|<arrow|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|<answer>>>>|<monad|<answer>>>>|\<varphi\>>>|&shift>>

  \;

  <slide|Monadic reflection>

  \;

  \;

  <\padded>
    Reflect/reify are definable from <strong|shift>/<strong|reset>:
  </padded>

  <space|1em><space|1em><space|1.2spc><meta-abbrev|<reify|t>|<app|<mreset>|<meta-paren|<app|<return>|t>>>>

  <space|1em><space|1em><meta-abbrev|<reflect|t>|<app|<mshift>|<meta-paren|<lam|k|<arrow|\<varphi\>|<monad|<answer>>>|<app|<app|<pbind>|k>|t>>>>>

  <\lemma*>
    The following typing rules are derivable:\ 

    \;

    <\eqnarray*>
      <tformat|<table|<row|<cell|<meta-rule|<typing|t|\<varphi\>>|<typing|<reify|t>|<monad|\<varphi\>>>|&reify>>|<cell|>|<cell|<meta-rule|<typing|t|<monad|\<varphi\>>>|<typing|<reflect|t>|\<varphi\>>|&reflect>>>>>
    </eqnarray*>
  </lemma*>

  \;

  <meta-solve|<meta-imp|<typing|t|\<varphi\>>|<typing|<reify|t>|<monad|\<varphi\>>>>>

  <meta-solve|<meta-imp|<typing|t|<monad|\<varphi\>>>|<typing|<reflect|t>|\<varphi\>>>>

  <slide|Polymorphic monadic reflection>

  \;

  <\padded>
    Polymorphic type for <strong|shift>:
  </padded>

  <meta-defn|<meta-rule#0||<typing|<mshift>|<arrow|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>|\<varphi\>>>|&shift>>

  <\padded>
    Reflect is still definable from <strong|shift>:
  </padded>

  <space|1em><space|1em><meta-abbrev|<reflect|t>|<app|<mshift>|<meta-paren|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<pbind>|k>|t>>>>>>

  <\lemma*>
    The following typing rule is derivable:\ 

    <\eqnarray*>
      <tformat|<table|<row|<cell|>|<cell|>|<cell|<meta-rule|<typing|t|<monad|\<varphi\>>>|<typing|<reflect|t>|\<varphi\>>|&reflect>>>>>
    </eqnarray*>
  </lemma*>

  <meta-solve|<meta-imp|<typing|t|<monad|\<varphi\>>>|<typing|<reflect|t>|\<varphi\>>>>

  <\remark*>
    <with|mode|math|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>>
    is equivalent to <with|mode|math|<monad|\<varphi\>>>.
  </remark*>

  <meta-solve|<meta-imp|<typing|t|<monad|\<varphi\>>>|<typing|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<pbind>|k>|t>>>|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>>>>

  <meta-solve|<meta-imp|<typing|f|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>>|<typing|<meta-paren|<app|<inst|f|\<varphi\>>|<return>>>|<monad|\<varphi\>>>>>

  <slide|Derived typing rule for reify>

  \;

  \;

  \;

  <meta-decl#0|<of_reify|<typing|t|\<varphi\>|>|<typing|<reify|t>|<monad|\<varphi\>>>>|<meta-type#0>>

  \;

  <paragraph|Proof.>

  <\very-small>
    <meta-defn|<meta-rule#0||<of_reify|<meta-term|<typing|t|\<varphi\>|>|\<cal-D\><rsub|of<rsub|1>>>|<meta-rule|<meta-hyps|<meta-rule||<typing|<mreset>|<arrow|<monad|\<varphi\>>|<monad|\<varphi\>>>>|&reset>|<meta-rule|<meta-hyps|<meta-rule||<typing|<return>|<arrow|\<varphi\>|<monad|\<varphi\>>>>|&unit>|<meta-term|<typing|t|\<varphi\>>|\<cal-D\><rsub|of<rsub|1>>>>|<typing|<app|<return>|t>|<monad|\<varphi\>>>|&app>>|<typing|<app|<mreset>|<meta-paren|<app|<return>|t>>>|<monad|\<varphi\>>>|&app>>|&>>

    \;

    \;

    \;

    <\padded>
      <meta-mode|<of_reify|+\<cal-D\><rsub|of<rsub|1>>|-\<cal-D\><rsub|of<rsub|2>>>>

      <meta-worlds|<meta-paren|><space|1em><of_reify|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>>>

      <meta-total|<meta-braces|><space|1em><of_reify|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>>>
    </padded>
  </very-small>

  <slide|Derived typing rule for reflect>

  \;

  <meta-decl#0|<of_reflect|<typing|t|<monad|\<varphi\>>|>|<typing|<reflect|t>|\<varphi\>>>|<meta-type#0>>

  \;

  <paragraph|Proof.>

  \;

  <\tiny>
    <\meta-defn>
      <meta-rule#0||<of_reflect|<meta-term|<typing|t|<monad|\<varphi\>>|>|\<cal-D\><rsub|of<rsub|t>>>|<meta-rule|<meta-hyps|<meta-rule#0|||&shift>|<meta-rule|<meta-abs|\<alpha\>|<meta-rule|<meta-term|<meta-all|k|<meta-imp|<typing|k|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<typing|<app|<app|<pbind>|k>|t>|<monad|\<alpha\>>>>>|<meta-abs|k|<meta-term|<meta-imp|<typing|k|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<typing|<app|<app|<pbind>|k>|t>|<monad|\<alpha\>>>>|<meta-abs|\<cal-D\><rsub|of<rsub|k>>|<meta-rule|<meta-hyps|<meta-rule|<meta-hyps|<meta-rule#0|||&bind>|<meta-term|<typing|k|<arrow|\<varphi\>|<monad|\<alpha\>>>>|\<cal-D\><rsub|of<rsub|k>>>>|<typing|<app|<pbind>|k>|<arrow|<monad|\<varphi\>>|<monad|\<alpha\>>>>|&app>|<meta-term|<typing|t|<monad|\<varphi\>>>|\<cal-D\><rsub|of<rsub|t>>>>|<typing|<app|<app|<pbind>|k>|t>|<monad|\<alpha\>>>|&app>>>>>|<typing|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<pbind>|k>|t>>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>|&lam>>|<typing|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<pbind>|k>|t>>>|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>>|&abs>>|<typing|<app|<mshift>|<meta-paren|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<pbind>|k>|t>>>>>|\<varphi\>>|&app>>|&>
    </meta-defn>

    \;

    \;

    \;

    \;

    <\padded>
      <meta-mode|<of_reflect|+\<cal-D\><rsub|of<rsub|1>>|-\<cal-D\><rsub|of<rsub|2>>>>

      <meta-worlds|<meta-paren|><space|1em><of_reflect|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>>>

      <meta-total|<meta-braces|><space|1em><of_reflect|\<cal-D\><rsub|of<rsub|1>>|\<cal-D\><rsub|of<rsub|2>>>>
    </padded>
  </tiny>

  <slide|Different continuation monads>

  \;

  \;

  <\padded>
    <\enumerate>
      <item><em|Continuation monad>

      <meta-abbrev|<kmonad|\<varphi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<answer>>>|<answer>>>

      \;

      <item><em|Modal continuation monad>

      <meta-abbrev|<kmonad|\<varphi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|<answer>>>>|<monad|<answer>>>>

      \;

      <item><em|Polymorphic continuation monad>

      <meta-abbrev|<kmonad|\<varphi\>>|<for_all|\<alpha\>|<arrow|<meta-paren|<arrow|\<varphi\>|\<alpha\>>>|\<alpha\>>>>

      \;

      <item><em|Polymorphic modal continuation monad>

      <meta-abbrev|<kmonad|\<varphi\>>|<for_all|\<alpha\>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>

      \;
    </enumerate>

    <\remark*>
      Cases 1 and 3 are obtained by taking <with|mode|math|<monad|>> as the
      identity monad.
    </remark*>
  </padded>

  <slide|Modal continuation monad>

  \;

  <meta-abbrev|<kmonad|\<varphi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|<answer>>>>|<monad|<answer>>>>

  \;

  <meta-abbrev|<kreturn>|<lam|t|\<varphi\>|<lam|k|<arrow|\<varphi\>|<monad|<answer>>>|<meta-paren|<app|k|t>>>>>

  <meta-abbrev|<kbind>|<\lam>
    k
  </lam|<arrow|\<varphi\>|<kmonad|\<psi\>>>|<lam|m|<kmonad|\<varphi\>>|<lam|c|<arrow|\<psi\>|<monad|<answer>>>|<app|m|<meta-paren|<lam|v|\<varphi\>|<app|<app|k|v>|c>>>>>>>>

  \;

  <meta-solve|<typing|<kreturn>|<arrow|\<varphi\>|<kmonad|\<varphi\>>>>>

  <meta-solve|<typing|<kbind>|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|\<psi\>>>>|<arrow|<kmonad|\<varphi\>>|<kmonad|\<psi\>>>>>>

  <slide|Polymorphic modal continuation monad>

  \;

  \;

  <meta-abbrev|<kmonad|\<varphi\>>|<for_all|\<alpha\>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>

  \;

  <meta-abbrev|<kreturn>|<lam|t|\<varphi\>|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<meta-paren|<app|k|t>>>>>>

  <meta-abbrev|<kbind>|<\lam>
    m
  </lam|<kmonad|\<varphi\>>|<lam|k|<arrow|\<varphi\>|<kmonad|\<psi\>>>|<lam2|\<alpha\>|<lam|c|<arrow|\<psi\>|<monad|\<alpha\>>>|<app|<inst|m|\<alpha\>>|<meta-paren|<lam|v|\<varphi\>|<app|<inst|<meta-paren|<app|k|v>>|\<alpha\>>|c>>>>>>>>>

  \;

  <meta-solve|<typing|<kreturn>|<arrow|\<varphi\>|<kmonad|\<varphi\>>>>>

  <meta-solve|<typing|<kbind>|<arrow|<kmonad|\<varphi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|\<psi\>>>>|<kmonad|\<psi\>>>>>>

  <slide|Polymorphic continuation monad (shift)>

  \;

  \;

  <meta-abbrev|<kmonad|\<varphi\>>|<for_all|\<alpha\>|<arrow|<meta-paren|<arrow|\<varphi\>|\<alpha\>>>|\<alpha\>>>>

  <meta-abbrev|<cpsshift>|<lam2|\<varphi\>|<lam|h|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|\<alpha\>>>>|<kmonad|\<alpha\>>>>>|<next-line><space|2em><space|2em><space|2em><lam2|\<alpha\>|<lam|c|<arrow|\<varphi\>|\<alpha\>>|<next-line><space|2em><space|2em><space|3em><meta-paren|<app|<inst|<meta-paren|<app|<inst|h|\<alpha\>>|<meta-paren|<lam|v|\<varphi\>|<lam2|\<alpha\><rprime|'>|<lam|c<rprime|'>|<arrow|\<alpha\>|\<alpha\><rprime|'>>|<app|c<rprime|'>|<meta-paren|<app|c|v>>>>>>>>>|\<alpha\>>|<lam|x|\<alpha\>|x>>>>>>>>

  \;

  <meta-decl#0|<of_cpsshift|<typing|<cpsshift>|<for_all|\<varphi\>|<arrow|<meta-paren|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|\<alpha\>>>>|<kmonad|\<alpha\>>>>>>|<kmonad|\<varphi\>>>>>>|<meta-type#0>>

  <paragraph|Proof.>

  <micro|<meta-defn|<meta-rule#0||<of_cpsshift|<meta-rule|<meta-abs|\<varphi\>|<meta-rule|<meta-abs|h|<meta-abs|\<cal-D\><rsub|of<rsub|h>>|<meta-rule|<meta-abs|\<alpha\>|<meta-rule|<meta-abs|c|<meta-abs|\<cal-D\><rsub|of<rsub|c>>|<meta-rule|<meta-hyps|<meta-rule|<meta-rule|<meta-hyps|<meta-rule|\<cal-D\><rsub|of<rsub|h>>||&inst>|<meta-rule|<meta-abs|v|<meta-abs|\<cal-D\><rsub|of<rsub|v>>|<meta-rule|<meta-abs|\<alpha\><rprime|'>|<meta-rule|<meta-abs|c<rprime|'>|<meta-abs|\<cal-D\><rsub|of<rsub|c<rprime|'>>>|<meta-rule|<meta-hyps|\<cal-D\><rsub|of<rsub|c<rprime|'>>>|<meta-rule|<meta-hyps|\<cal-D\><rsub|of<rsub|c>>|\<cal-D\><rsub|of<rsub|v>>>||&app>>||&app>>>||&lam>>||&abs>>>||&lam>>||&app>||&inst>|<meta-rule|<meta-abs|x|<meta-abs|\<cal-D\><rsub|of<rsub|x>>|\<cal-D\><rsub|of<rsub|x>>>>||&lam>>||&app>>>||&lam>>||&abs>>>||&lam>>|<typing|<cpsshift>|<for_all|\<varphi\>|<arrow|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|\<alpha\>>>>|<kmonad|\<alpha\>>>>>|<kmonad|\<varphi\>>>>>|&abs>>|&>>>

  \;

  \;

  <\padded>
    <\small>
      <meta-mode|<of_cpsshift|-\<cal-D\><rsub|of>>>

      <meta-worlds|<meta-paren|><space|1em><of_cpsshift|\<cal-D\><rsub|of>>>

      <meta-total|<meta-braces|><space|1em><of_cpsshift|\<cal-D\><rsub|of>>>
    </small>
  </padded>

  <\slide>
    Polymorphic modal continuation monad (shift)
  </slide>

  \;

  \;

  <meta-abbrev|<kmonad|\<varphi\>>|<for_all|\<alpha\>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>

  <meta-abbrev|<cpsshift>|<lam2|\<varphi\>|<lam|h|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|<monad|\<alpha\>>>>>|<kmonad|<monad|\<alpha\>>>>>>|<next-line><space|2em><space|2em><space|2em><lam2|\<alpha\>|<lam|c|<arrow|\<varphi\>|<monad|\<alpha\>>>|<next-line><space|2em><space|2em><space|3em><meta-paren|<app|<inst|<meta-paren|<app|<inst|h|\<alpha\>>|<meta-paren|<lam|v|\<varphi\>|<lam2|\<alpha\><rprime|'>|<lam|c<rprime|'>|<arrow|<monad|\<alpha\>>|<monad|\<alpha\><rprime|'>>>|<app|c<rprime|'>|<meta-paren|<app|c|v>>>>>>>>>|\<alpha\>>|<lam|x|<monad|\<alpha\>>|x>>>>>>>>

  \;

  <meta-decl#0|<of_cpsshift|<typing|<cpsshift>|<for_all|\<varphi\>|<arrow|<meta-paren|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|<monad|\<alpha\>>>>>|<kmonad|<monad|\<alpha\>>>>>>>|<kmonad|\<varphi\>>>>>>|<meta-type#0>>

  <paragraph|Proof.>

  <micro|<meta-defn|<meta-rule#0||<of_cpsshift|<meta-rule|<meta-abs|\<varphi\>|<meta-rule|<meta-abs|h|<meta-abs|\<cal-D\><rsub|of<rsub|h>>|<meta-rule|<meta-abs|\<alpha\>|<meta-rule|<meta-abs|c|<meta-abs|\<cal-D\><rsub|of<rsub|c>>|<meta-rule|<meta-hyps|<meta-rule|<meta-rule|<meta-hyps|<meta-rule|\<cal-D\><rsub|of<rsub|h>>||&inst>|<meta-rule|<meta-abs|v|<meta-abs|\<cal-D\><rsub|of<rsub|v>>|<meta-rule|<meta-abs|\<alpha\><rprime|'>|<meta-rule|<meta-abs|c<rprime|'>|<meta-abs|\<cal-D\><rsub|of<rsub|c<rprime|'>>>|<meta-rule|<meta-hyps|\<cal-D\><rsub|of<rsub|c<rprime|'>>>|<meta-rule|<meta-hyps|\<cal-D\><rsub|of<rsub|c>>|\<cal-D\><rsub|of<rsub|v>>>||&app>>||&app>>>||&lam>>||&abs>>>||&lam>>||&app>||&inst>|<meta-rule|<meta-abs|x|<meta-abs|\<cal-D\><rsub|of<rsub|x>>|\<cal-D\><rsub|of<rsub|x>>>>||&lam>>||&app>>>||&lam>>||&abs>>>||&lam>>|<typing|<cpsshift>|<for_all|\<varphi\>|<arrow|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<kmonad|<monad|\<alpha\>>>>>|<kmonad|<monad|\<alpha\>>>>>>|<kmonad|\<varphi\>>>>>|&abs>>|&>>>

  \;

  \;

  <\padded>
    <\small>
      <meta-mode|<of_cpsshift|-\<cal-D\><rsub|of>>>

      <meta-worlds|<meta-paren|><space|1em><of_cpsshift|\<cal-D\><rsub|of>>>

      <meta-total|<meta-braces|><space|1em><of_cpsshift|\<cal-D\><rsub|of>>>
    </small>
  </padded>

  <slide|Example: the continuation monad>

  \;

  <meta-constant|<monad|\<varphi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<answer>>>|<answer>>>

  \;

  <meta-constant|<mreturn|\<varphi\>>|<lam|t|\<varphi\>|<lam|k|<arrow|\<varphi\>|<answer>>|<meta-paren|<app|k|t>>>>>

  <\meta-constant|<mbind|\<varphi\>|\<psi\>>>
    <\lam>
      k
    </lam|<arrow|\<varphi\>|<monad|\<psi\>>>|<lam|m|<monad|\<varphi\>>|<lam|c|<arrow|\<psi\>|<answer>>|<app|m|<meta-paren|<lam|v|\<varphi\>|<app|<app|k|v>|c>>>>>>>
  </meta-constant>

  \;

  <meta-solve|<typing|<mreturn|\<varphi\>>|<arrow|\<varphi\>|<monad|\<varphi\>>>>>

  <meta-solve|<typing|<mbind|\<varphi\>|\<psi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<psi\>>>>|<arrow|<monad|\<varphi\>>|<monad|\<psi\>>>>>>

  \;

  <meta-defn|<next-line><meta-rule#0||<typing|<mreset>|<arrow|<monad|\<varphi\>>|<monad|\<varphi\>>>>|<rsub|>reset>><next-line><meta-defn|<next-line><meta-rule#0||<typing|<mshift>|<arrow|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>|\<varphi\>>>|<rsub|>shift>>

  \;

  <meta-constant|<reify|t>|<app|<mreset>|<meta-paren|<app|<mreturn|\<varphi\>>|t>>>>

  <meta-constant|<reflect|t>|<app|<mshift>|<meta-paren|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<mbind|\<varphi\>|\<alpha\>>|k>|t>>>>>>

  \;

  <meta-solve|<meta-imp|<typing|t|\<varphi\>>|<typing|<reify|t>|<monad|\<varphi\>>>>>

  <meta-solve|<meta-imp|<typing|t|<monad|\<varphi\>>>|<typing|<reflect|t>|\<varphi\>>>>

  \;

  <slide|Example: the continuation monad>

  \;

  <\padded>
    Defining <escape> in direct style:
  </padded>

  <meta-abbrev|<escape>|<lam|h|<arrow|<meta-paren|<arrow|\<varphi\>|\<psi\>>>|\<varphi\>>|<reflect|<lam|c|<arrow|\<varphi\>|<answer>>|<app|<reify|<app|h|<lam|a|\<varphi\>|<reflect|<lam|c<rprime|'>|<arrow|\<psi\>|<answer>>|<app|c|a>>>>>>|c>>>>>

  \;

  <meta-solve|<typing|<escape>|<arrow|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|\<psi\>>>|\<varphi\>>>|\<varphi\>>>>

  \;

  <\padded>
    <strong|What is the logical meaning of>
    <with|mode|math|<arrow|<monad|\<varphi\>>|\<varphi\>>>?
  </padded>

  <\padded>
    Since <with|mode|math|\<diamondsuit\>\<varphi\>\<equiv\><around*|(|\<varphi\>\<Rightarrow\><answer>|)>\<Rightarrow\><answer>>,
    for some formula <math|<answer>>, we get
    <math|\<neg\>\<neg\>\<varphi\>\<Rightarrow\>\<varphi\>> which extends the
    logic to classical logic if we take <math|<answer>=\<bot\>>, but this
    axiom is incoherent if <math|<answer>> is a theorem (note that it is
    always at least classical logic).
  </padded>

  <slide|Example: the state monad>

  \;

  <meta-decl|<state>|<tp>>

  <meta-abbrev|<monad|\<varphi\>>|<arrow|<state>|<meta-paren|<product|\<varphi\>|<state>>>>>

  \;

  <meta-abbrev|<mreturn|\<varphi\>>|<lam|a|\<varphi\>|<lam|s|<state>|<pair|a|s>>>>

  <meta-abbrev|<mbind|\<varphi\>|\<psi\>>|<lam|f|<arrow|\<varphi\>|<monad|\<psi\>>>|<lam|t|<monad|\<varphi\>>|<lam|s|<state>|<let|x|s<rprime|'>|<app|t|s>|<app|<app|f|x>|s<rprime|'>>>>>>>

  \;

  <meta-solve|<typing|<mreturn|\<varphi\>>|<arrow|\<varphi\>|<monad|\<varphi\>>>>>

  <meta-solve|<typing|<mbind|\<varphi\>|\<psi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<psi\>>>>|<arrow|<monad|\<varphi\>>|<monad|\<psi\>>>>>>

  \;

  <meta-defn|<next-line><meta-rule#0||<typing|<mreset>|<arrow|<monad|\<varphi\>>|<monad|\<varphi\>>>>|<rsub|>reset>><next-line><meta-defn|<next-line><meta-rule#0||<typing|<mshift>|<arrow|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>|\<varphi\>>>|<rsub|>shift>>

  \;

  <meta-constant|<reify|t>|<app|<mreset>|<meta-paren|<app|<mreturn|\<varphi\>>|t>>>>

  <meta-constant|<reflect|t>|<app|<mshift>|<meta-paren|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<mbind|\<varphi\>|\<alpha\>>|k>|t>>>>>>

  \;

  <meta-solve|<meta-imp|<typing|t|\<varphi\>>|<typing|<reify|t>|<monad|\<varphi\>>>>>

  <meta-solve|<meta-imp|<typing|t|<monad|\<varphi\>>>|<typing|<reflect|t>|\<varphi\>>>>

  <slide|Example: the state monad>

  \;

  <\padded>
    Defining <mget> and <mset> in direct style:
  </padded>

  \;

  <meta-abbrev|<unit>|<for_all|\<alpha\>|<arrow|\<alpha\>|\<alpha\>>>>

  <meta-abbrev|<single>|<lam2|\<alpha\>|<lam|x|\<alpha\>|x>>>

  \;

  <meta-solve|<typing|<single>|<unit>>>

  \;

  <meta-abbrev|<mset>|<lam|n|<state>|<reflect|<lam|s|<state>|<pair|<single>|n>>>>>

  <meta-abbrev|<mget>|<lam|x|<unit>|<reflect|<lam|s|<state>|<pair|s|s>>>>>

  \;

  <meta-solve|<typing|<mget>|<arrow|<unit>|<state>>>>

  <meta-solve|<typing|<mset>|<arrow|<state>|<unit>>>>

  \;

  <\padded>
    <strong|What is the logical meaning of>
    <with|mode|math|<arrow|<monad|\<varphi\>>|\<varphi\>>>?
  </padded>

  <\padded>
    Since <with|mode|math|\<diamondsuit\>\<varphi\>\<equiv\><state>\<Rightarrow\><around*|(|\<varphi\>\<wedge\><state>|)>>,
    for some formula <math|<state>>, we get
    <with|mode|math|<around*|(|<state>\<Rightarrow\><around*|(|\<varphi\>\<wedge\><state>|)>|)>\<Rightarrow\>\<varphi\>>
    which is not valid in general. This axiom is derivable if <math|<state>>
    is a theorem, but it is incoherent if we take <math|<state>=\<bot\>>.
  </padded>

  <slide|Example: the exception monad>

  \;

  <meta-decl|<exn>|<tp>>

  <meta-abbrev|<monad|\<varphi\>>|<disjunction|\<varphi\>|<exn>>>

  \;

  <meta-abbrev|<mreturn|\<varphi\>>|<lam|a|\<varphi\>|<inl|a>>>

  <meta-abbrev|<mbind|\<varphi\>|\<psi\>>|<lam|f|<arrow|\<varphi\>|<monad|\<psi\>>>|<lam|t|<monad|\<varphi\>>|<cases|t|a|<app|f|a>|b|<inr|b>>>>>

  \;

  <meta-solve|<typing|<mreturn|\<varphi\>>|<arrow|\<varphi\>|<monad|\<varphi\>>>>>

  <meta-solve|<typing|<mbind|\<varphi\>|\<psi\>>|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<psi\>>>>|<arrow|<monad|\<varphi\>>|<monad|\<psi\>>>>>>

  \;

  <meta-defn|<next-line><meta-rule#0||<typing|<mreset>|<arrow|<monad|\<varphi\>>|<monad|\<varphi\>>>>|<rsub|>reset>><next-line><meta-defn|<next-line><meta-rule#0||<typing|<mshift>|<arrow|<for_all|\<alpha\>|<meta-paren|<arrow|<meta-paren|<arrow|\<varphi\>|<monad|\<alpha\>>>>|<monad|\<alpha\>>>>>|\<varphi\>>>|<rsub|>shift>>

  \;

  <meta-constant|<reify|t>|<app|<mreset>|<meta-paren|<app|<mreturn|\<varphi\>>|t>>>>

  <meta-constant|<reflect|t>|<app|<mshift>|<meta-paren|<lam2|\<alpha\>|<lam|k|<arrow|\<varphi\>|<monad|\<alpha\>>>|<app|<app|<mbind|\<varphi\>|\<alpha\>>|k>|t>>>>>>

  \;

  <meta-solve|<meta-imp|<typing|t|\<varphi\>>|<typing|<reify|t>|<monad|\<varphi\>>>>>

  <meta-solve|<meta-imp|<typing|t|<monad|\<varphi\>>>|<typing|<reflect|t>|\<varphi\>>>>

  <slide|Example: the exception monad>

  \;

  <\padded>
    Defining <raise> and <try> in direct style:
  </padded>

  \;

  <meta-abbrev|<raise>|<lam|e|<exn>|<reflect|<inr|e>>>>

  <meta-abbrev|<try>|<lam|t|\<varphi\>|<lam|h|<arrow|<exn>|\<varphi\>>|<cases|<reify|t>|a|a|e|<app|h|e>>>>>

  \;

  <meta-solve|<typing|<raise>|<arrow|<exn>|\<alpha\>>>>

  <meta-solve|<typing|<try>|<arrow|\<varphi\>|<arrow|<meta-paren|<arrow|<exn>|\<varphi\>>>|\<varphi\>>>>>

  \;

  \;

  <\padded>
    <strong|What is the logical meaning of>
    <with|mode|math|<arrow|<monad|\<varphi\>>|\<varphi\>>>?
  </padded>

  <\padded>
    Since <with|mode|math|\<diamondsuit\>\<varphi\>\<equiv\>\<varphi\>\<vee\><exn>>,
    for some formula <exn>, we get <with|mode|math|<around*|(|\<varphi\>\<vee\><exn>|)>\<Rightarrow\>\<varphi\>>
    which is not valid in general. This axiom is incoherent if <exn> is a
    theorem, but it is derivable if <math|\<neg\><exn>> is derivable.
  </padded>

  <meta-end>

  <\slide>
    Concluding remarks
  </slide>

  <\padded>
    \;

    <\itemize>
      <item>Depending on <with|mode|math|<monad|>>, the type of
      <strong|shift> can be:

      <\itemize-minus>
        <item><with|font-shape|italic|intuitionistic>

        <item><with|font-shape|italic|classical>

        <item><with|font-shape|italic|incoherent>
      </itemize-minus>

      <item>However a proof of \ <with|mode|math|\<vdash\>\<bot\>> is
      translated into a proof <math|\<vdash\>\<diamondsuit\>\<bot\>>

      (and the target logic is consistent since <with|mode|math|<monad|>> is
      defined)

      <item>In a dependently typed framework
      <with|mode|math|<typing|<mreset>|<arrow|<monad|\<varphi\>>|<monad|\<varphi\>>>>>
      is useless.

      Is it just an optimization?

      <item>Similarly, we can replace <strong|shift> by the
      <math|\<cal-D\>>-operator.

      <item>Why should we expect <strong|shift> to be logically sound?
    </itemize>
  </padded>

  <\bibliography|bib|plainnat|biblio>
    <\bib-list|2>
      <bibitem*|Curry(1952)><label|bib-Curry52>H.<nbsp>B. Curry.
      <newblock>The elimination theorem when modality is present.
      <newblock><with|font-shape|italic|The Journal of Symbolic Logic>, 17
      (4): 249--265, 1952. <newblock>ISSN 0022-4812.

      <bibitem*|Filinski(1994)><label|bib-Filinski94>A.<nbsp>Filinski.
      <newblock>Representing monads. <newblock>In
      <with|font-shape|italic|Conference Record of the Twenty-First Annual
      Symposium on Principles of Programming Languages>, pages 446--457,
      Portland, Oregon, January 1994.
    </bib-list>
  </bibliography>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|10>
    <associate|info-flag|short>
    <associate|page-medium|paper>
    <associate|page-orientation|landscape>
    <associate|page-screen-margin|false>
    <associate|preamble|false>
    <associate|sfactor|7>
    <associate|src-compact|all>
    <associate|src-style|angular>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|4>>
    <associate|auto-10|<tuple|1.2.2.1|?>>
    <associate|auto-2|<tuple|1|9>>
    <associate|auto-3|<tuple|2|19>>
    <associate|auto-4|<tuple|3|20>>
    <associate|auto-5|<tuple|4|24>>
    <associate|auto-6|<tuple|5|25>>
    <associate|auto-7|<tuple|<with|mode|<quote|math>|\<bullet\>>|33>>
    <associate|auto-8|<tuple|<with|mode|<quote|math>|\<bullet\>>|22>>
    <associate|auto-9|<tuple|7|5>>
    <associate|bib-Curry52|<tuple|Curry(1952)|33>>
    <associate|bib-Filinski94|<tuple|Filinski(1994)|33>>
    <associate|footnote-|<tuple|?|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|bib>
      Filinski94

      Filinski94

      Curry52

      Curry52

      Filinski94

      Filinski94

      Curry52

      Curry52
    </associate>
    <\associate|toc>
      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.15fn>>

      <with|par-left|<quote|1.5fn>|<with|color|<quote|dark blue>|Types>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3><vspace|0.15fn>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4><vspace|0.15fn>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5><vspace|0.15fn>>

      <with|par-left|<quote|6fn>|Proof. <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6><vspace|0.15fn>>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|<new-page*><with|color|<quote|dark
      blue>|Bibliography>> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>